--    Program: 		CAPARIMP_CUSTOMER_PAYMENT_METHOD.sql
--    Description:  Import AR CUSTOMER PAYMENT METHOD information 
--    Revision:     1st     
--    Parameter: 	
--    Created By:   Kenny Leung
--    Date:         1-Feb-2006

set doc off;      
set verify off;
set serveroutput on size 1000000;
--whenever sqlerror exit failure rollback;

declare   
   l_processed_count		number;
   l_rejected_count 		number;
   l_err_msg				varchar2(2000);
   l_err_msg_tmp 			varchar2(2000);
   
   l_cust_receipt_method_id	number;
                    		                 		
   cursor cur_ar_customer_receipt_method is
      select * from CRST_RA_CUST_RECEIPT_METHODS
      for update;

begin
   l_processed_count := 0;
   l_rejected_count  := 0;
   l_err_msg := '';
   
   for cur in cur_ar_customer_receipt_method loop   	
     l_err_msg_tmp := '';
     
     SELECT RA_CUST_RECEIPT_METHODS_S.NEXTVAL 
     INTO l_cust_receipt_method_id
     FROM DUAL;
     
     update CRST_RA_CUST_RECEIPT_METHODS
     set    cust_receipt_method_id_n = l_cust_receipt_method_id
     where  cust_receipt_method_id = cur.cust_receipt_method_id;
     
     begin
       -- import data
       insert into RA_CUST_RECEIPT_METHODS
       (
              CUST_RECEIPT_METHOD_ID  ,
              CUSTOMER_ID             ,
              RECEIPT_METHOD_ID       ,
              PRIMARY_FLAG            ,
              LAST_UPDATE_DATE        ,
              LAST_UPDATED_BY         ,
              CREATION_DATE           ,
              CREATED_BY              ,
              LAST_UPDATE_LOGIN       ,
              REQUEST_ID              ,
              PROGRAM_APPLICATION_ID  ,
              PROGRAM_ID              ,
              PROGRAM_UPDATE_DATE     ,
              SITE_USE_ID             ,
              START_DATE              ,
              END_DATE                ,
              ATTRIBUTE_CATEGORY      ,
              ATTRIBUTE1              ,
              ATTRIBUTE2              ,
              ATTRIBUTE3              ,
              ATTRIBUTE4              ,
              ATTRIBUTE5              ,
              ATTRIBUTE6              ,
              ATTRIBUTE7              ,
              ATTRIBUTE8              ,
              ATTRIBUTE9              ,
              ATTRIBUTE10             ,
              ATTRIBUTE11             ,
              ATTRIBUTE12             ,
              ATTRIBUTE13             ,
              ATTRIBUTE14             ,
              ATTRIBUTE15              
       )
       values
       (
            l_cust_receipt_method_id    ,
            cur.CUSTOMER_ID				,
            cur.RECEIPT_METHOD_ID       ,
            cur.PRIMARY_FLAG            ,
            cur.LAST_UPDATE_DATE        ,
            CAPBRIMP_MAPPING.GetUserMapping(cur.LAST_UPDATED_BY),
            cur.CREATION_DATE           ,
            CAPBRIMP_MAPPING.GetUserMapping(cur.CREATED_BY),
            cur.LAST_UPDATE_LOGIN       ,
            cur.REQUEST_ID              ,
            cur.PROGRAM_APPLICATION_ID  ,
            cur.PROGRAM_ID              ,
            cur.PROGRAM_UPDATE_DATE     ,
            CAPARIMP_MAPPING.GetHZSiteUseIDMapping(cur.SITE_USE_ID),
            cur.START_DATE              ,
            cur.END_DATE                ,
            cur.ATTRIBUTE_CATEGORY      ,
            cur.ATTRIBUTE1              ,
            cur.ATTRIBUTE2              ,
            cur.ATTRIBUTE3              ,
            cur.ATTRIBUTE4              ,
            cur.ATTRIBUTE5              ,
            cur.ATTRIBUTE6              ,
            cur.ATTRIBUTE7              ,
            cur.ATTRIBUTE8              ,
            cur.ATTRIBUTE9              ,
            cur.ATTRIBUTE10             ,
            cur.ATTRIBUTE11             ,
            cur.ATTRIBUTE12             ,
            cur.ATTRIBUTE13             ,
            cur.ATTRIBUTE14             ,
            cur.ATTRIBUTE15                               
       );  
     exception
       when others then
     	 l_err_msg_tmp := sqlerrm;
     end;	  	    
     
     if l_err_msg_tmp = '' then
       l_processed_count := l_processed_count + 1;  
     else
       l_rejected_count := l_rejected_count + 1;
       l_err_msg := l_err_msg_tmp; 
     end if;  	  
   end loop;
   
   if l_rejected_count <> 0 then
   	 commit;
   else
     rollback;
   end if;
   
   -- insert into log table
   insert into capcnv_log ( prog_id,process_date, record_processed,record_rejected,record_extracted,err_msg) 
    values ('CAPARIMP_CUSTOMER_PAYMENT_METHOD', sysdate, l_processed_count, l_rejected_count, l_processed_count-l_rejected_count, l_err_msg );
   
   commit;
exception 
  when others then
    dbms_output.put_line(sqlerrm);
    rollback;  
end;
/


--exit
